
The `csmngr` utility daemon is used for Wi-Fi Auto Channel Planning and Dynamic
Channel selection.

When started, it reads the "wireless" UCI config file to know the list of Wi-Fi
radio interfaces that have option "channel" set to either "auto" or 0.
Accordingly, it proceeds to collect channel characteristics such as channel-time,
tx-time, rx-time, busy-time, noise etc. for all channels supported by the radio
interfaces.
It then uses the collected data to compute 'Optimal' channels for all possible
channel-and-bandwidth combinations supported by the radios.

Finally, csmngr can set the newly found optimal channel into the wireless driver
if certain conditions are fulfilled or instructed to do so via the CLI.

## Build and build config ##

Run 'make' from within the "src" directory to build the 'csmngr' utility
daemon. See **Dependencies** section for the prerequisites.

For install, run 'make install'. This will install 'csmngr' to the default
install path at '/usr/sbin'.

## Configuration ##

'csmngr' uses '/etc/config/wireless', which is also the 'wireless' UCI file.

## CLI (through UBUS) ##

When running, 'csmngr' provides the following UBUS methods -

````bash
root@iopsys:~# ubus -v list wifi.acs
'wifi.acs' @3d13e5b5
        "status":{}
        "results":{}
        "refresh":{"radio":"String","band":"Integer"}
        "scan":{"radio":"String","band":"Integer","freq":"Integer","channel":"Integer","duration":"Integer"}
        "dump_survey":{"radio":"String","band":"Integer","freq":"Integer","channel":"Integer"}
````

An example output of the *ubus call wifi.acs results* call showing the predicted
optimal channels for each supported bandwidth combinations by the Wi-Fi radios -

````bash
root@iopsys:~# ubus call wifi.acs results
{
        "radios": [
                {
                        "name": "radio0_band0",
                        "band": "2g",
                        "verdict": [
                                {
                                        "channel": 11,
                                        "bandwidth": 20,
                                        "interference-factor": 0.471150
                                },
                                {
                                        "channel": 6,
                                        "bandwidth": 40,
                                        "interference-factor": 0.650304
                                }
                        ]
                },
                {
                        "name": "radio0_band1",
                        "band": "5g",
                        "verdict": [
                                {
                                        "channel": 149,
                                        "bandwidth": 20,
                                        "interference-factor": 0.000000
                                },
                                {
                                        "channel": 149,
                                        "bandwidth": 40,
                                        "interference-factor": 0.000000
                                },
                                {
                                        "channel": 149,
                                        "bandwidth": 80,
                                        "interference-factor": 0.000000
                                },
                                {
                                        "channel": 36,
                                        "bandwidth": 160,
                                        "interference-factor": 0.061599
                                }
                        ]
                },
                {
                        "name": "radio0_band2",
                        "band": "6g",
                        "verdict": [
                                {
                                        "channel": 81,
                                        "bandwidth": 20,
                                        "interference-factor": 0.000000
                                },
                                {
                                        "channel": 81,
                                        "bandwidth": 40,
                                        "interference-factor": 0.000000
                                },
                                {
                                        "channel": 49,
                                        "bandwidth": 80,
                                        "interference-factor": 0.003160
                                }
                        ]
                }
        ]
}

````

## Dependencies ##

'csmngr' requires the following libraries and software components for build and run-time dependencies:

| Dependency  		| Link                                       						| License        |
| -----------------	| ----------------------------------------------------------------			| -------------- |
| libeasy	  	| https://dev.iopsys.eu/hal/libeasy.git							| LGPL 2.1       |
| libwifi	  	| https://dev.iopsys.eu/hal/libwifi.git							| LGPL 2.1       |
| libuci      		| https://git.openwrt.org/project/uci.git     					 	| LGPL 2.1       |
| libubox     		| https://git.openwrt.org/project/libubox.git 					 	| ISC            |
| libblobmsg_json	| https://git.openwrt.org/project/libubox.git						| ISC		 |
| libubus     		| https://git.openwrt.org/project/ubus.git    					 	| LGPL 2.1       |
| libjson-c   		| https://s3.amazonaws.com/json-c_releases    					 	| MIT            |
| libnl-3	  	| https://github.com/thom311/libnl.git							| LGPLv2.1	 |
| libnl-genl-3  	| https://github.com/thom311/libnl.git                                            	| LGPLv2.1       |
| libnl-route-3  	| https://github.com/thom311/libnl.git                                            	| LGPLv2.1       |
| libmnl		| https://git.netfilter.org/libmnl                                            		| LGPLv2.1       |

